/*
	Zadatak 4.
*/

#include <stdio.h>

// ------------------------------------- GRUPA A -----------------------------
int izrazA( int k, int b )
{
	int potencija = 1, i;
	
	for( i = 0; i < k; ++i )
	    potencija *= b;
	    
	return 2*potencija + k;
}

double p( int x, int y, int b )
{
	int sumaTakvih = 0, brojTakvih = 0, k = 0;
	double sumaTakvihDouble;
	
	if( b < 0 ) b = -b;
	
	while( izrazA( k, b ) < x )
	    ++k;
	    
	while( izrazA( k, b ) <= y )
	{
		sumaTakvih += izrazA( k, b );
		++brojTakvih;
		++k;
	}
	
	sumaTakvihDouble = sumaTakvih;
	return brojTakvih == 0 ? 0 : sumaTakvihDouble / brojTakvih;
}

// ------------------------------------- GRUPA B -----------------------------
int izrazB( int k, int b )
{
	int potencija = 1, i;

	for( i = 0; i < k; ++i )
	    potencija *= b;

	return potencija - k;
}

int q( int b, int f, int t )
{
	int sumaTakvih = 0, k = 1;
	
	if( b < 0 ) b = -b;

	if( b < 2 ) // fja je padajuca za b=0, 1
	{
		while( izrazB( k, b ) >= t )
		    ++k;
		    
		while( izrazB( k, b ) > f )
		{
			sumaTakvih += k;
			++k;
		}
	}
	else // fja je rastuca
	{
		while( izrazB( k, b ) <= f )
		    ++k;

		while( izrazB( k, b ) < t )
		{
			sumaTakvih += k;
			++k;
		}
	}

	return sumaTakvih;
}
// ------------------------------------- GRUPA C -----------------------------
double r( int n )
{
	int sumaProstih = 0, brojProstih = 0;
	double sumaProstihDouble;

	if( n < 0 ) n = -n;
	
	while( n > 0 )
	{
		int znamenka = n % 10;
		n /= 10;
		
		if( znamenka == 2 || znamenka == 3 || znamenka == 5 || znamenka == 7 )
		{
		    sumaProstih += znamenka;
		    ++brojProstih;
		}
	}
	
	sumaProstihDouble = sumaProstih;
	return brojProstih == 0 ? 0 : sumaProstihDouble / brojProstih;
}

// ------------------------------------- GRUPA D -----------------------------
int s( double x )
{
	int xInt = x, suma = 0, najvecaZnamenka = -1, kolikoNajvecih = 0;

	if( x < 0 ) return 0;
	
	while( xInt > 0 )
	{
		if( najvecaZnamenka == xInt % 10 )
			++kolikoNajvecih;
		else if( najvecaZnamenka < xInt % 10 )
		{
			najvecaZnamenka = xInt % 10;
			kolikoNajvecih = 1;
		}
		
		suma += xInt % 10;
		xInt /= 10;
	}
	
	return suma - najvecaZnamenka * kolikoNajvecih;
}


/* ne treba pisati, samo za testiranje */
int main( void )
{
	printf( "Grupa A: p( 5, 50, 2 ) = %lf\n", p( 5, 50, 2 ) );
	printf( "Grupa B: q( 2, 5, 50 ) = %d\n", q( 2, 5, 50 ) );
	printf( "Grupa C: r( -5052786 ) = %lf\n", r( -5052786 ) );
	printf( "Grupa D: s( 271828.1 ) = %d\n", s( 271828.1 ) );

	return 0;
}
