#include <stdio.h>

int a(int x, int y) {
  x = 2*x + 1;
  y = 3*y - 2;
  if (x < 0) x = -x;
  if (y < 0) y = -y;
  while (y > 0) {
    int t = x % y;
    x = y;
    y = t;
  }
  return x;
}

int b(int n) {
  int min, max;
  min = max = n % 10;
  while (n /= 10) {
    int z = n % 10;
    if (z > max) max = z;
    if (z < min) min = z;
  }
  return min + max;
}

int c(int b, unsigned n) {
  long pot = 1, old_pot, reverse = 0;
  while (n--) pot *= b;
  old_pot = pot;
  while (pot > 0) {
    reverse = 10 * reverse + pot % 10;
    pot /= 10;
  }
  return reverse == old_pot;
}

int d(unsigned n) {
  int log = 0, i;
  while (n /= 16) ++log;
  if (log < 2) return 0;
  for (i = 2; i < log; i++)
    if (log % i == 0) return 0;
  return 1;
}

int main(void) {
  printf("a(%d, %d) = %d\t(2*%1$d+1 = %d, 3*%2$d-2 = %d)\n", 7, 19, a(7, 19), 2*7+1, 3*19-2);
  printf("b(%d) = %d\n", 27487, b(27487));
  printf("c(%d, %d) = %d, c(%2$d, %1$d) = %d\n", 11, 2, c(11, 2), c(2, 11));
  printf("d(%d) = %d, d(%d) = %d, d(%d) = %d\n", 1234, d(1234), 12345, d(12345), 123456, d(123456));
  return 0;
}
