#include <stdio.h>

#ifdef GRUPA_A

typedef double T;

const char* format = "%g\n";

int a(int x, int y) {
  x = 2*x + 1;
  y = 3*y - 2;
  while (y > 0) {
    int t = x % y;
    x = y;
    y = t;
  }
  return x;
}

#endif

#ifdef GRUPA_B

typedef int T;

const char* format = "%d\n";

int b(int n) {
  int min, max;
  min = max = n % 10;
  while (n /= 10) {
    int z = n % 10;
    if (z > max) max = z;
    if (z < min) min = z;
  }
  return min + max;
}

#endif

#ifdef GRUPA_C

typedef int T;

const char* format = "%d\n";

double r(int n){
	int suma = 0;
	int br_znam = 0;
	if(n == 0) return 0;
	if(n < 0) n = -n;
	while(n > 0){
		int z = n % 10;
		if(z == 2 || z == 3 || z == 5 || z == 7){
			suma += z;
			++br_znam;
			}
		n /= 10;
		}
	return (double) suma / br_znam;
	}

#endif

#ifdef GRUPA_D

typedef double T;

const char* format = "%g\n";

int s(double x){
	int cijeli_dio = (int) x;
	int suma = 0;
	int max_zn = -1;
	int kopija = cijeli_dio;
	while(kopija > 0){
		int z = kopija % 10;
		if(z > max_zn) max_zn = z;
		kopija /= 10;
		}
	while(cijeli_dio > 0){
		int z = cijeli_dio % 10;
		if(z != max_zn) suma += z;
		cijeli_dio /= 10;
		}
	return suma;
	}	

#endif


int main(void){
	
	T niz[] = {(T) 313.4, (T) 424.2, (T) 372.1, (T) 5.0, (T) 28.7, (T) 0.22};
	int n = sizeof(niz) / sizeof(T);
	int i;
	int j;
	
	for(i = 0; i < n-1; ++i)
		for(j = i + 1; j < n; ++j)
			if(
#ifdef GRUPA_A
				a(682, niz[i]) > a(682, niz[j])
#endif
#ifdef GRUPA_B
				b(niz[i]) > b(niz[j])
#endif
#ifdef GRUPA_C
				r(niz[i]) < r(niz[j])
#endif
#ifdef GRUPA_D
				s(niz[i]) < s(niz[j])
#endif
				){ /* closes if-test */
				T tmp = niz[i];
				niz[i] = niz[j];
				niz[j] = tmp;
			}
			
	for(i = 0; i < n; printf(format, niz[i++])); 

	return 0;
	}			

